/*
  Ӥ߿ͤ襯饹
  Satofumi KAMIMURA
  $Id$
*/

#include "yomibitoDraw.h"
#include "wakaDraw.h"


// ʸ
void YomibitoDraw::drawMoji(SDL_Rect *position, Uint16 uch,
			    int fontSize, int alpha) {
  Uint16 moji[2] = { 0x00, 0x00 };
  moji[0] = uch;
  SDL_Surface *wch = ttf.createSurface(moji, fontSize, BLACK);
  SDL_SetAlpha(wch, SDL_SRCALPHA, SDL_ALPHA_OPAQUE * alpha / 100);
  scr.blitSurface(wch, NULL, scr.screen(), position);
  SDL_FreeSurface(wch);
}


// Ӥ
void YomibitoDraw::rubiDraw(SDL_Rect *position, int percentage) {
  
  // Ĺ硢setps != 0 ˤƤɽ
  int offset = 0;
  int steps = 0;
  if (RUBI_FS * rubiSize < TYPE_FS * kanjiSize) {
    offset = RUBI_FS / 2;
    if (RUBI_FS * rubiSize + offset < TYPE_FS * kanjiSize) {
      steps = (surfaceLength - (RUBI_FS * rubiSize + offset)) / rubiSize;
    }
  }

  SDL_Rect pos;
  pos.y = position->y - RUBI_FS;
  for (int i = 0; i < rubiSize; ++i) {
    pos.x = position->x - surfaceLength + (RUBI_FS + steps) * i + offset;
    drawMoji(&pos, yomibitoResource.yomi[i], RUBI_FS, percentage);
  }
}


// 
void YomibitoDraw::kanjiDraw(SDL_Rect *position, int percentage) {
  
  // ӤĹ硢offset 餷ɽ򳫻Ϥ
  int offset = (RUBI_FS * rubiSize > TYPE_FS * kanjiSize) ?
    (surfaceLength - TYPE_FS * kanjiSize) / 2 : 0;

  SDL_Rect pos;
  pos.y = position->y;
  for (int i = 0; i < kanjiSize; ++i) {
    pos.x = position->x - surfaceLength + TYPE_FS * i + offset;
    drawMoji(&pos, yomibitoResource.kanji[i], TYPE_FS, percentage);
  }
}


// Ⱥи뤿
void YomibitoDraw::drawRight(SDL_Rect *position, int percentage) {

  // ӡĹĹǤäư·
  kanjiDraw(position, percentage);
  rubiDraw(position, percentage);
}


// Ӥ߿ͤξꤷƤΥ֥
YomibitoDraw::YomibitoDraw(const yomibitoResource_t yomibito,
			   ScreenCtrl& scr, FontCtrl& ttf)
  : yomibitoResource(yomibito), scr(scr), ttf(ttf) {

  // ӡեĹ׻
  kanjiSize = WakaDraw::getUniLen(yomibito.kanji);
  rubiSize = WakaDraw::getUniLen(yomibito.yomi);

  surfaceLength = (TYPE_FS * kanjiSize > RUBI_FS * rubiSize)
    ? TYPE_FS * kanjiSize : RUBI_FS * rubiSize;
}
