#ifndef YOMIBITO_DRAW_H
#define YOMIBITO_DRAW_H

/*
  Ӥ߿ͤ襯饹
  Satofumi KAMIMURA
  $Id$
*/

#include "wakaResource.h"
#include "screenCtrl.h"
#include "fontCtrl.h"


class YomibitoDraw {
  yomibitoResource_t yomibitoResource;
  ScreenCtrl& scr;
  FontCtrl& ttf;
  int kanjiSize;
  int rubiSize;
  int surfaceLength;

  void rubiDraw(SDL_Rect *position, int percentage);
  void kanjiDraw(SDL_Rect *position, int percentage);
  void drawMoji(SDL_Rect *position, Uint16 wch, int fontSize, int alpha);
  YomibitoDraw();
  
public:
  void drawRight(SDL_Rect *position, int percentage);
  YomibitoDraw(const yomibitoResource_t yomibito,
	       ScreenCtrl& scr, FontCtrl& ttf);
};

#endif /* !YOMIBITO_DRAW_H */
