#ifndef DRAW_UTILS_H
#define DRAW_UTILS_H

/*
  $B6&DL$KMxMQ$9$kIA2h4X?t(B
  Satofumi KAMIMURA
  $Id$
*/

#include "screenCtrl.h"
#include "fontCtrl.h"
#include "soundCtrl.h"
#include "timer.h"
#include "convert.h"
#include "wakaResource.h"


extern void gameExit(void);
extern bool waitFirstMusicEnd(int msec, ScreenCtrl& scr,
			      FontCtrl& ttf, SoundCtrl& snd, Timer& soundTimer,
			      Uint16 titleTTF[]);
extern void drawInputArea(ScreenCtrl& scr, FontCtrl& ttf,
			  const SDL_Rect *position, Convert& cnv, int mode);
extern void drawTotalWakaTyped(ScreenCtrl& scr, FontCtrl& ttf,
			       int num, int all);
extern void drawResultText(ScreenCtrl& scr, FontCtrl& ttf,
			   Uint16 name[], char char_str[], Uint16 tani[],
			   SDL_Rect *namePos, SDL_Rect *resultPos);
extern void learnMode(ScreenCtrl& scr, FontCtrl& ttf, SoundCtrl& snd,
		      WakaResource& waka, int ids[], int max);
extern void drawWakaNum(ScreenCtrl& scr, FontCtrl& ttf, int num);
extern int calcWakaNum(int n);

#endif /* !DRAW_UTILS_H */
